/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

function setup()
{
	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		// The preferences are retrieved:
		var worldString = widget.preferenceForKey(makeKey("worldString"));

		if (worldString && worldString.length > 0)  // if the retrieved preferences are not empty,
		{											// they are restored.
			document.getElementById("worldText").innerText = worldString;

			var imgname = worldString;
			document.getElementById("pict").src = "images/" + imgname + "/"+ imgname + "_1.png";


			if( worldString == "Mika")	// if Goodbye is the retreived value...
			{
				document.getElementById("worldPopup").selectedIndex = 0;	// set the popup to reflect that.
			}
		}
	setInterval(changeImage,150);
	}
}


// changeWorld() is called whenever a menu item is chosen in the widget's preferences.  It queries the
// menu to find out which option was chosen, applies the change to the widget, and saves the preference.

var imgname = "Mika";
var imgpage = 6;

function changeWorld(elem)
{	
	var world = document.getElementById("worldText");

	
	switch( parseInt(elem.options[elem.selectedIndex].value) )					// find out which option was chosen
	{
		case 1: 						// if option #1
			world.innerText="Mika";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Mika",makeKey("worldString"));		// and save the new preference to disk
			}
			imgname = "Mika";
			imgpage = 6;
			changeImage()
			break;
			
		case 2:						// if option #2
			world.innerText="Chica";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Chica",makeKey("worldString"));	// save the new preference to disk
			}
			imgname = "Chica";
			imgpage = 6;
			changeImage()
			break;
		case 3:						// if option #3
			world.innerText="Chiyo";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Chiyo",makeKey("worldString"));	// save the new preference to disk
			}
			imgname = "Chiyo";
			imgpage = 2;
			changeImage()
			break;
		case 4:						// if option #4
			world.innerText="Hituji";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Hituji",makeKey("worldString"));	// save the new preference to disk
			}
			imgname = "Hituji";
			imgpage = 13;
			changeImage()
			break;
		case 5: 						// if option #5
			world.innerText="Haduki";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Haduki",makeKey("worldString"));		// and save the new preference to disk
			}
			imgname = "Haduki";
			imgpage = 12;
			changeImage()
			break;
			
		case 6: 						// if option #6
			world.innerText="Minaduki";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Minaduki",makeKey("worldString"));		// and save the new preference to disk
			}
			imgname = "Minaduki";
			imgpage = 17;
			changeImage()
			break;
			
		case 7: 						// if option #7
			world.innerText="Satsuki";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("Satsuki",makeKey("worldString"));		// and save the new preference to disk
			}
			imgname = "Satsuki";
			imgpage = 14;
			changeImage()
			break;
			
		case 8: 						// if option #8
			world.innerText="J05017";		// change the front text
			if(window.widget)
			{
				widget.setPreferenceForKey("J05017",makeKey("worldString"));		// and save the new preference to disk
			}
			imgname = "J05017";
			imgpage = 6;
			changeImage()
			break;
	}
} 


//changeImage() changing pict's img

var imgnum = 0;

function changeImage()
{
	var img = imgname;
	var imgend = imgpage + 1;
	imgnum++;
	if(imgnum == imgend) imgnum = 1;
	document.getElementById("pict").src = "images/" + img + "/"+ img + "_" + imgnum + ".png";
}


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() clicked preferences flipper  show back
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() clicked done button show front

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// makeKey() makes the widget multi-instance aware

function makeKey(key)
{
	return (widget.identifier + "-" + key);
}


/***************/
// WIDGET EVENTS
/***************/

// removed() when widget is removed from the Dashboard

function removed()
{

	widget.setPreferenceForKey(null,makeKey("worldString"));
}

// focused() when the widget gets key focus

function focused()
{
	document.getElementById('worldText').style.color = 'white'; 
}

// blurred() when the widget looses key focus

function blurred()
{
	document.getElementById('worldText').style.color = 'gray'; 
}

// Here we register for some widget events

if(window.widget)
{
	widget.onremove = removed;
	window.onfocus = focused;
	window.onblur = blurred;
}	


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() when mousemove on the front 

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mousemove() when mouseexit from the front 

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() preferences flipper's fade animation

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// limit_3() for animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

// computeNextFloat() for animate()

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// enterflip() when the info button itself receives onmouseover

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

// exitflip() when the info button itself receives onmouseout

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}